Index: /trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- /trunk/src/org/expeditee/gui/Frame.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Frame.java	(revision 1102)
@@ -19,9 +19,4 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Image;
-import java.awt.Polygon;
-import java.awt.image.ImageObserver;
-import java.awt.image.VolatileImage;
 import java.sql.Time;
 import java.util.ArrayList;
@@ -37,4 +32,10 @@
 
 import org.expeditee.actions.Simple;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.input.StandardInputEventListeners;
+import org.expeditee.gio.input.KBMInputEvent.Key;
 import org.expeditee.io.Conversion;
 import org.expeditee.items.Constraint;
@@ -50,5 +51,5 @@
 import org.expeditee.items.UserAppliedPermission;
 import org.expeditee.items.XRayable;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.settings.UserSettings;
@@ -66,12 +67,21 @@
  * 
  */
-public class Frame implements ImageObserver {
+public class Frame {
+	
+	/** The frame number to indicate this is a virtual frame. */
+	public static final int VIRTUAL_FRAME_NUMBER = -1;
+	
+	/** The background colour the frame name should take if the frame has user permission level 'none'. */
+	public static final Colour FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_NONE = Colour.FromRGB255(255, 220, 220);
+	/** The background colour the frame name should take if the frame has user permission level 'followLinks'. */
+	public static final Colour FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_FOLLOW_LINKS = Colour.FromRGB255(255, 230, 135);
+	/** The background colour the frame name should take if the frame has user permission level 'copy'. */
+	public static final Colour FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_COPY = Colour.FromRGB255(255, 255, 155);
+	/** The background colour the frame name should take if the frame has user permission level 'createFrames'. */
+	public static final Colour FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_CREATE_FRAMES = Colour.FromRGB255(220, 255, 220);
+	/** The background colour the frame name should take if the frame has user permission level 'full'. */
+	public static final Colour FRAME_NAME_BACKGROUND_COLOUR_FOR_PERMISSION_FULL = null;
 
 	private boolean _protectionChanged = false;
-
-	public boolean isReadOnly() {
-		return !_frameName.hasPermission(UserAppliedPermission.full)
-				&& !_protectionChanged;
-	}
 
 	// The various attributes of this Frame
@@ -95,8 +105,8 @@
 
 	// Background color is clear
-	private Color _background = null;
+	private Colour _background = null;
 
 	// Foreground color is automatic by default
-	private Color _foreground = null;
+	private Colour _foreground = null;
 
 	private String path;
@@ -105,29 +115,10 @@
 
 	private boolean _sorted = true;
-
-	// The items contained in this Frame
-	// records whether a change has been made to this Frame (for saving
-	// purposes).
+	
+	/** Whether the frame has changed and therefore needs saving. */
 	private boolean _change = false;
 
+	/** Whether the frame has been saved. */
 	private boolean _saved = false;
-
-	private static final class History {
-		public enum Type {
-			deletion,
-			movement
-		}
-		public final List<Item> items;
-		public final Type type;
-		
-		public History(Collection<Item> items, Type type) {
-			this.items = new LinkedList<Item>(items);
-			this.type = type;
-		}
-		
-		public String toString() {
-			return this.type.toString() + ":\n" + this.items.toString();
-		}
-	}
 	
 	// list of deleted items that can be restored
@@ -141,5 +132,5 @@
 
 	// for drawing purposes
-	private List<InteractiveWidget> _iWidgets = new ArrayList<InteractiveWidget>();
+	private List<Widget> _iWidgets = new ArrayList<Widget>();
 
 	private int _lineCount = 0;
@@ -170,64 +161,74 @@
 	private Text _dotTemplate = TemplateSettings.DotTemplate.get().copy();
 
-	/**
-	 * Default constructor, nothing is set.
-	 */
-	public Frame() {
-	}
-
-	public void reset() {
+	Map<String, Text> _annotations = null;
+
+	private Collection<FrameObserver> _observers = new HashSet<FrameObserver>();
+
+	/** Default constructor, nothing is set. */
+	public Frame()
+	{
+	}
+
+	public boolean isReadOnly()
+	{
+		return !_frameName.hasPermission(UserAppliedPermission.full) && !_protectionChanged;
+	}
+
+	public void reset()
+	{
 		refreshItemPermissions(UserAppliedPermission.full);
-		//System.out.println("Reset");
 		resetDot();
 		SessionStats.NewFrameSession();
 	}
 
-	private void resetDot() {
+	private void resetDot()
+	{
 	    _dotTemplate.setColor(TemplateSettings.ColorWheel.getSafe(1));
 	    _dotTemplate.setFillColor(TemplateSettings.FillColorWheel.getSafe(0));
 	}
 
-	public void nextDot() {
-		_dotTemplate.setFillColor(ColorUtils.getNextColor(_dotTemplate
-				.getFillColor(), TemplateSettings.FillColorWheel.get(), null));
-		_dotTemplate.setColor(ColorUtils.getNextColor(_dotTemplate.getColor(),
-				TemplateSettings.ColorWheel.get(), null));
-
-		if (_dotTemplate.getColor() == null || _dotTemplate.getColor().equals(Color.white)) {
-			resetDot();
-		}
-	}
-
-	public Image getBuffer() {
+	public void nextDot()
+	{
+		_dotTemplate.setFillColor(ColorUtils.getNextColor(_dotTemplate.getFillColor(), TemplateSettings.FillColorWheel.get(), null));
+		_dotTemplate.setColor(ColorUtils.getNextColor(_dotTemplate.getColor(), TemplateSettings.ColorWheel.get(), null));
+		if (_dotTemplate.getColor() == null || _dotTemplate.getColor().equals(Colour.WHITE)) resetDot();
+	}
+
+	public Image getBuffer()
+	{
 		return _buffer;
 	}
 
-	public void setBuffer(Image newBuffer) {
+	public void setBuffer(Image newBuffer)
+	{
 		_buffer = newBuffer;
 	}
 
-	public boolean isBufferValid() {
-		if (_buffer == null
-				|| (_buffer instanceof VolatileImage && ((VolatileImage) _buffer)
-						.contentsLost()))
-			return false;
+	public boolean isBufferValid()
+	{
+		if (_buffer == null) return false;
 
 		return _validBuffer;
 	}
 
-	private void setBufferValid(boolean newValue) {
+	private void setBufferValid(boolean newValue)
+	{
 		_validBuffer = newValue;
 	}
 
-	public int getNextItemID() {
+	public int getNextItemID()
+	{
 		return ++_itemCount;
 	}
 
-	public void updateIDs(List<Item> items) {
-		for (Item i : items)
-			if (!(i instanceof Line))
+	public void updateIDs(List<Item> items)
+	{
+		for (Item i : items) {
+			if (!(i instanceof Line)) {
 				i.setID(getNextItemID());
-			else
+			} else {
 				i.setID(++_lineCount);
+			}
+		}
 	}
 
@@ -237,6 +238,7 @@
 	 *         Hence it excludes free-widgets. Returns a copy
 	 */
-	public List<InteractiveWidget> getInteractiveWidgets() {
-		LinkedList<InteractiveWidget> clone = new LinkedList<InteractiveWidget>();
+	public List<Widget> getInteractiveWidgets()
+	{
+		LinkedList<Widget> clone = new LinkedList<Widget>();
 		clone.addAll(this._iWidgets);
 		return clone;
@@ -248,8 +250,8 @@
 	 * @return True if this Frame has been altered, false otherwise.
 	 */
-	public boolean hasChanged() {
+	public boolean hasChanged()
+	{
 		// virtual frames are never saved
-		if (_number == -1)
-			return false;
+		if (_number == VIRTUAL_FRAME_NUMBER) return false;
 
 		return _change;
@@ -260,16 +262,9 @@
 	 * 
 	 * @param value
-	 *            False if this Frame should be saved to disk, False otherwise.
-	 */
-	public void setChanged(boolean value) {
-		// System.out.println(getName() + " " + value);
-		boolean oldValue = _change;
-
-		// if (value) {
-		// notifyObservers();
-		// }
-
-		if (oldValue == value)
-			return;
+	 *            True if this Frame should be saved to disk, False otherwise.
+	 */
+	public void setChanged(boolean value)
+	{
+		if (_change == value) return;
 
 		_change = value;
@@ -281,6 +276,4 @@
 	}
 
-	// private static int updateCount = 0;
-
 	/**
 	 * Notify items observing the data on this frame that the frame content has
@@ -290,8 +283,7 @@
 	 *            true if the frame should be recalculated first.
 	 */
-	public void notifyObservers(boolean bRecalculate) {
-		if (bRecalculate) {
-			recalculate();
-		}
+	public void notifyObservers(boolean bRecalculate)
+	{
+		if (bRecalculate) recalculate();
 		// Notify the frame listeners that the frame has changed
 		/*
@@ -301,16 +293,15 @@
 		 * changing this frames observer list.
 		 */
-		Collection<FrameObserver> observersCopy = new LinkedList<FrameObserver>(
-				_observers);
+		Collection<FrameObserver> observersCopy = new LinkedList<FrameObserver>(_observers);
 		// System.out.println(++updateCount + " update");
 
 		for (FrameObserver fl : observersCopy) {
-			if (/* !Item.isLocked(fl) && */fl.isVisible())
-				fl.update();
+			if (fl.isVisible()) fl.update();
 		}
 	}
 
 	// indicates the frame has changed
-	public void change() {
+	public void change()
+	{
 		setChanged(true);
 		_interactableItems.clear();
@@ -323,9 +314,14 @@
 	 * @return The list of Item objects that are on this Frame.
 	 */
-	public List<Item> getItems(boolean visible) {
+	public List<Item> getItems(boolean visible)
+	{
 		if (!_sorted) {
-			for(int i = 0; i < _body.size();)
-				if(_body.get(i) == null) _body.remove(i);
-				else i++;
+			for(int i = 0; i < _body.size();) {
+				if(_body.get(i) == null) {
+					_body.remove(i);
+				} else {
+					i++;
+				}
+			}
 			Collections.sort(_body);
 			_sorted = true;
@@ -335,6 +331,6 @@
 
 		for (Item i : _body) {
-			if (i == null)
-				continue;
+			if (i == null) continue;
+			
 			if (i.isVisible() || (!visible && !i.isDeleted())) {
 				items.add(i);
@@ -345,5 +341,7 @@
 	}
 
-	public List<Item> getItems() {
+	/** TODO: Comment. cts16 */
+	public List<Item> getItems()
+	{
 		return getItems(false);
 	}
@@ -354,7 +352,8 @@
 	 * @return True if this frame contains i.
 	 */
-	public boolean containsItem(Item i) {
-		if (i == null)
-			throw new NullPointerException("i");
+	public boolean containsItem(Item i)
+	{
+		if (i == null) throw new NullPointerException("i");
+		
 		return _body.contains(i);
 	}
@@ -372,15 +371,15 @@
 	 * @return the list of body text items.
 	 */
-	public List<Text> getBodyTextItems(boolean includeAnnotations) {
+	public List<Text> getBodyTextItems(boolean includeAnnotations)
+	{
 		List<Text> bodyTextItems = new ArrayList<Text>();
+		
 		for (Item i : getItems(true)) {
 			// only add up normal body text items
-			if ((i instanceof Text)
-					&& ((includeAnnotations && !((Text) i)
-							.isSpecialAnnotation()) || !i.isAnnotation())
-					&& !i.isLineEnd()) {
+			if ((i instanceof Text) && ((includeAnnotations && !((Text) i).isSpecialAnnotation()) || !i.isAnnotation()) && !i.isLineEnd()) {
 				bodyTextItems.add((Text) i);
 			}
 		}
+		
 		bodyTextItems.remove(getTitleItem());
 
@@ -388,15 +387,16 @@
 	}
 
-	public Collection<Item> getNonAnnotationItems(boolean removeTitle) {
+	public Collection<Item> getNonAnnotationItems(boolean removeTitle)
+	{
 		Collection<Item> items = new ArrayList<Item>();
 		for (Item i : getItems(true)) {
 			// only add up normal body text items
-			if (!i.isAnnotation()) {
-				items.add(i);
-			}
-		}
+			if (!i.isAnnotation()) items.add(i);
+		}
+		
 		if (removeTitle) {
 			items.remove(getTitleItem());
 		}
+		
 		return items;
 	}
@@ -408,5 +408,6 @@
 	 * @return the last non annotation text item.
 	 */
-	public Item getLastNonAnnotationTextItem() {
+	public Item getLastNonAnnotationTextItem()
+	{
 		List<Item> items = getItems();
 
@@ -431,9 +432,11 @@
 	 *         found.
 	 */
-	public Item getItemWithID(int id) {
-		for (Item i : _body)
-			if (i.getID() == id)
+	public Item getItemWithID(int id)
+	{
+		for (Item i : _body) {
+			if (i.getID() == id) {
 				return i;
-
+			}
+		}
 		return null;
 	}
@@ -445,7 +448,7 @@
 	 *            The title to assign to this Frame
 	 */
-	public void setTitle(String title) {
-		if (title == null || title.equals(""))
-			return;
+	public void setTitle(String title)
+	{
+		if (title == null || title.equals("")) return;
 
 		boolean oldchange = _change;
@@ -476,7 +479,6 @@
 			// title = ItemUtils.StripTagSymbol(title);
 			frameTitle.setText(title);
-			// If the @ symbol is followed by numbering or a bullet remove that
-			// too
-			String autoBulletText = FrameKeyboardActions.getAutoBullet(title);
+			// If the @ symbol is followed by numbering or a bullet remove that too
+			String autoBulletText = StandardGestureActions.getAutoBullet(title);
 			if (autoBulletText.length() > 0)
 				frameTitle.stripFirstWord();
@@ -485,6 +487,5 @@
 		// Brook: Cannot figure what is going on above... widget annot titles
 		// should be stripped always
-		if (ItemUtils.startsWithTag(frameTitle, ItemUtils
-				.GetTag(ItemUtils.TAG_IWIDGET))) {
+		if (ItemUtils.startsWithTag(frameTitle, ItemUtils.GetTag(ItemUtils.TAG_IWIDGET))) {
 			frameTitle.stripFirstWord();
 		}
@@ -496,10 +497,12 @@
 	}
 
-	public Text getTitleItem() {
+	public Text getTitleItem()
+	{
 		List<Item> items = getVisibleItems();
+		
 		for (Item i : items) {
-			if (i instanceof Text && i.getX() < UserSettings.TitlePosition.get()
-					&& i.getY() < UserSettings.TitlePosition.get())
+			if (i instanceof Text && i.getX() < UserSettings.TitlePosition.get() && i.getY() < UserSettings.TitlePosition.get()) {
 				return (Text) i;
+			}
 		}
 
@@ -507,24 +510,25 @@
 	}
 
-	public String getTitle() {
+	public String getTitle()
+	{
 		Text title = getTitleItem();
-		if (title == null)
-			return getName();
+		if (title == null) return getName();
 
 		return title.getFirstLine();
 	}
 
-	public Item getNameItem() {
+	public Item getNameItem()
+	{
 		return _frameName;
 	}
 
-	public Text getItemTemplate() {
-		return getTemplate(TemplateSettings.ItemTemplate.get(),
-				ItemUtils.TAG_ITEM_TEMPLATE);
-	}
-
-	public Text getAnnotationTemplate() {
-		Text t = getTemplate(TemplateSettings.AnnotationTemplate.get(),
-				ItemUtils.TAG_ANNOTATION_TEMPLATE);
+	public Text getItemTemplate()
+	{
+		return getTemplate(TemplateSettings.ItemTemplate.get(), ItemUtils.TAG_ITEM_TEMPLATE);
+	}
+
+	public Text getAnnotationTemplate()
+	{
+		Text t = getTemplate(TemplateSettings.AnnotationTemplate.get(), ItemUtils.TAG_ANNOTATION_TEMPLATE);
 
 		if (t == null) {
@@ -535,8 +539,8 @@
 	}
 
-	public Text getStatTemplate() {
+	public Text getStatTemplate()
+	{
 		SessionStats.CreatedText();
-		Text t = getTemplate(TemplateSettings.StatTemplate.get(),
-				ItemUtils.TAG_STAT_TEMPLATE);
+		Text t = getTemplate(TemplateSettings.StatTemplate.get(), ItemUtils.TAG_STAT_TEMPLATE);
 
 		if (t == null) {
@@ -547,21 +551,25 @@
 	}
 	
-	public Item getTooltipTextItem(String tooltipText) {
+	public Item getTooltipTextItem(String tooltipText)
+	{
 		return getTextItem(tooltipText, TemplateSettings.TooltipTemplate.get().copy());
 	}
 
-	public Item getStatsTextItem(String itemText) {
+	public Item getStatsTextItem(String itemText)
+	{
 		return getTextItem(itemText, getStatTemplate());
 	}
 
-	public Item getTextItem(String itemText) {
+	public Item getTextItem(String itemText)
+	{
 		return getTextItem(itemText, getItemTemplate());
 	}
 
-	private Item getTextItem(String itemText, Text template) {
+	private Item getTextItem(String itemText, Text template)
+	{
 		Text t = template;
 		// We dont want the stats to wrap at all
 		// t.setMaxWidth(Integer.MAX_VALUE);
-		t.setPosition(DisplayIO.getMouseX(), FrameMouseActions.getY());
+		t.setPosition(DisplayController.getMousePosition());
 		// The next line is needed to make sure the item is removed from the
 		// frame when picked up
@@ -571,7 +579,7 @@
 	}
 
-	public Text getCodeCommentTemplate() {
-		Text t = getTemplate(TemplateSettings.CommentTemplate.get(), 
-				ItemUtils.TAG_CODE_COMMENT_TEMPLATE);
+	public Text getCodeCommentTemplate()
+	{
+		Text t = getTemplate(TemplateSettings.CommentTemplate.get(), ItemUtils.TAG_CODE_COMMENT_TEMPLATE);
 
 		if (t == null) {
@@ -592,5 +600,6 @@
 	 *         Item.intersects(shape) return true.
 	 */
-	public Collection<Item> getItemsWithin(Polygon poly) {
+	public Collection<Item> getItemsWithin(PolygonBounds poly)
+	{
 		Collection<Item> results = new LinkedHashSet<Item>();
 		for (Item i : getVisibleItems()) {
@@ -606,7 +615,8 @@
 		}
 
-		for (Overlay o : _overlays.keySet())
+		for (Overlay o : _overlays.keySet()) {
 			results.addAll(o.Frame.getItemsWithin(poly));
-
+		}
+		
 		for (Item i : getVectorItems()) {
 			if (i.intersects(poly)) {
@@ -626,9 +636,11 @@
 	 *            The name to use for this Frame.
 	 */
-	public void setFrameset(String name) {
+	public void setFrameset(String name)
+	{
 		_frameset = name;
 	}
 
-	public void setName(String framename) {
+	public void setName(String framename)
+	{
 		int num = Conversion.getFrameNumber(framename);
 		String frameset = Conversion.getFramesetName(framename, false);
@@ -643,9 +655,9 @@
 	 *            The number to set as the frame number
 	 */
-	public void setFrameNumber(int number) {
+	public void setFrameNumber(int number)
+	{
 		assert (number >= 0);
 
-		if (_number == number)
-			return;
+		if (_number == number) return;
 
 		_number = number;
@@ -659,4 +671,5 @@
 			id = -1 * getNextItemID();
 		}
+		
 		_frameName = new Text(id);
 		_frameName.setParent(this);
@@ -671,5 +684,6 @@
 	 * @return The Frame number of this Frame or -1 if it is not set.
 	 */
-	public int getNumber() {
+	public int getNumber()
+	{
 		return _number;
 	}
@@ -681,5 +695,6 @@
 	 *            The version to use for this Frame.
 	 */
-	public void setVersion(int version) {
+	public void setVersion(int version)
+	{
 		_version = version;
 	}
@@ -691,12 +706,13 @@
 	 *            The protection to use for this Frame.
 	 */
-	public void setPermission(PermissionPair permission) {
-		if (_permissionPair != null && _permissionPair.getPermission(this._owner).equals(permission))
+	public void setPermission(PermissionPair permission)
+	{
+		if (_permissionPair != null && _permissionPair.getPermission(this._owner).equals(permission)) {
 			_protectionChanged = true;
+		}
 
 		_permissionPair = new PermissionPair(permission);
 
-		if (_body.size() > 0)
-			refreshItemPermissions(permission.getPermission(_owner));
+		if (_body.size() > 0) refreshItemPermissions(permission.getPermission(_owner));
 	}
 
@@ -707,5 +723,6 @@
 	 *            The owner to use for this Frame.
 	 */
-	public void setOwner(String owner) {
+	public void setOwner(String owner)
+	{
 		_owner = owner;
 	}
@@ -717,5 +734,6 @@
 	 *            The date to use for this Frame.
 	 */
-	public void setDateCreated(String date) {
+	public void setDateCreated(String date)
+	{
 		_creationDate = date;
 		_modifiedDate = date;
@@ -729,5 +747,6 @@
 	 * 
 	 */
-	public void resetDateCreated() {
+	public void resetDateCreated()
+	{
 		setDateCreated(Formatter.getDateTime());
 		resetTimes();
@@ -735,5 +754,6 @@
 	}
 
-	private void resetTimes() {
+	private void resetTimes()
+	{
 		setActiveTime(new Time(0));
 		setDarkTime(new Time(0));
@@ -746,5 +766,6 @@
 	 *            The user to set as the last modifying user.
 	 */
-	public void setLastModifyUser(String user) {
+	public void setLastModifyUser(String user)
+	{
 		_modifiedUser = user;
 	}
@@ -756,5 +777,6 @@
 	 *            The date to set as the last modified date.
 	 */
-	public void setLastModifyDate(String date) {
+	public void setLastModifyDate(String date)
+	{
 		_modifiedDate = date;
 	}
@@ -766,9 +788,11 @@
 	 *            The date to set as the last frozen date.
 	 */
-	public void setFrozenDate(String date) {
+	public void setFrozenDate(String date)
+	{
 		_frozenDate = date;
 	}
 
-	public void setResort(boolean value) {
+	public void setResort(boolean value)
+	{
 		_sorted = !value;
 	}
@@ -780,11 +804,12 @@
 	 *            The Item to add to this Frame.
 	 */
-	public void addItem(Item item) {
+	public void addItem(Item item)
+	{
 		addItem(item, true);
 	}
 
-	public void addItem(Item item, boolean recalculate) {
-		if (item == null || item.equals(_frameName) || _body.contains(item))
-			return;
+	public void addItem(Item item, boolean recalculate)
+	{
+		if (item == null || item.equals(_frameName) || _body.contains(item)) return;
 
 		// When an annotation item is anchored the annotation list must be
@@ -794,6 +819,5 @@
 		}
 
-		if (item instanceof Line)
-			_lineCount++;
+		if (item instanceof Line) _lineCount++;
 
 		_itemCount = Math.max(_itemCount, item.getID());
@@ -816,15 +840,15 @@
 		// add widget items to the list of widgets
 		if (item instanceof WidgetCorner) {
-			InteractiveWidget iw = ((WidgetCorner) item).getWidgetSource();
+			Widget iw = ((WidgetCorner) item).getWidgetSource();
 			if (!this._iWidgets.contains(iw)) { // A set would have been
-				if (FrameMouseActions.isControlDown())
+				if (StandardInputEventListeners.kbmStateListener.isKeyDown(Key.CTRL)) {
 					_iWidgets.add(iw);
-				else
+				} else {
 					_iWidgets.add(0, iw);
-			}
-		}
-
-		item.onParentStateChanged(new ItemParentStateChangedEvent(this,
-				ItemParentStateChangedEvent.EVENT_TYPE_ADDED));
+				}
+			}
+		}
+
+		item.onParentStateChanged(new ItemParentStateChangedEvent(this, ItemParentStateChangedEvent.EVENT_TYPE_ADDED));
 
 		// if (recalculate && item.recalculateWhenChanged())
@@ -834,12 +858,13 @@
 	}
 
-	public void refreshSize() {
-		// assert (size != null);
+	public void refreshSize()
+	{
 		boolean bReparse = false;
+		
 		for (Item i : getItems()) {
-			Float anchorLeft   = i.getAnchorLeft();
-			Float anchorRight  = i.getAnchorRight();
-			Float anchorTop    = i.getAnchorTop();
-			Float anchorBottom = i.getAnchorBottom();
+			Integer anchorLeft   = i.getAnchorLeft();
+			Integer anchorRight  = i.getAnchorRight();
+			Integer anchorTop    = i.getAnchorTop();
+			Integer anchorBottom = i.getAnchorBottom();
 	
 			
@@ -885,9 +910,9 @@
 	}
 
-	public void addAllItems(Collection<Item> toAdd) {
+	public void addAllItems(Collection<Item> toAdd)
+	{
 		for (Item i : toAdd) {
 			// If an annotation is being deleted clear the annotation list
-			if (i.isAnnotation())
-				i.getParentOrCurrentFrame().clearAnnotations();
+			if (i.isAnnotation()) i.getParentOrCurrentFrame().clearAnnotations();
 			// TODO Improve efficiency when addAll is called
 			addItem(i);
@@ -895,21 +920,22 @@
 	}
 
-	public void removeAllItems(Collection<Item> toRemove) {
+	public void removeAllItems(Collection<Item> toRemove)
+	{
 		for (Item i : toRemove) {
 			// If an annotation is being deleted clear the annotation list
-			if (i.isAnnotation())
-				i.getParentOrCurrentFrame().clearAnnotations();
+			if (i.isAnnotation()) i.getParentOrCurrentFrame().clearAnnotations();
 			removeItem(i);
 		}
 	}
 
-	public void removeItem(Item item) {
+	public void removeItem(Item item)
+	{
 		removeItem(item, true);
 	}
 
-	public void removeItem(Item item, boolean recalculate) {
+	public void removeItem(Item item, boolean recalculate)
+	{
 		// If an annotation is being deleted clear the annotation list
-		if (item.isAnnotation())
-			item.getParentOrCurrentFrame().clearAnnotations();
+		if (item.isAnnotation()) item.getParentOrCurrentFrame().clearAnnotations();
 
 		if (_body.remove(item)) {
@@ -917,9 +943,10 @@
 			// Remove widgets from the widget list
 			if (item != null) {
-				item.onParentStateChanged(new ItemParentStateChangedEvent(this,
-						ItemParentStateChangedEvent.EVENT_TYPE_REMOVED));
+				item.onParentStateChanged(new ItemParentStateChangedEvent(this, ItemParentStateChangedEvent.EVENT_TYPE_REMOVED));
+				
 				if (item instanceof WidgetCorner) {
 					_iWidgets.remove(((WidgetCorner) item).getWidgetSource());
 				}
+				
 				item.invalidateCommonTrait(ItemAppearence.Removed);
 			}
@@ -937,26 +964,27 @@
 	 * @param type  The type of event that occurred
 	 */
-	private void addToUndo(Collection<Item> items, History.Type type) {
-		if (items.size() < 1)
-			return;
-		
-		// System.out.println("Added: " + items);
+	private void addToUndo(Collection<Item> items, History.Type type)
+	{
+		if (items.size() < 1) return;
 
 		_undo.push(new History(items, type));
 	}
 	
-	public void addToUndoDelete(Collection<Item> items) {
+	public void addToUndoDelete(Collection<Item> items)
+	{
 		addToUndo(items, History.Type.deletion);
 	}
-	public void addToUndoMove(Collection<Item> items) {
+	
+	public void addToUndoMove(Collection<Item> items)
+	{
 		addToUndo(items, History.Type.movement);
 	}
 
-	public void undo() {
+	public void undo()
+	{
 		boolean bReparse = false;
 		boolean bRecalculate = false;
 
-		if (_undo.size() <= 0)
-			return;
+		if (_undo.size() <= 0) return;
 
 		History undo = _undo.pop();
@@ -992,6 +1020,9 @@
 			break;
 		}
+		
 		change();
-		FrameMouseActions.getInstance().refreshHighlights();
+		
+		StandardGestureActions.refreshHighlights();
+		
 		if (bReparse) {
 			FrameUtils.Parse(this, false, false);
@@ -999,19 +1030,19 @@
 			notifyObservers(bRecalculate);
 		}
+		
 		// always request a refresh otherwise filled shapes
 		// that were broken by a deletion and then reconnected by the undo
 		// don't get filled until the user otherwise causes them to redraw
-		FrameGraphics.requestRefresh(false);
-		FrameGraphics.Repaint();
+		DisplayController.requestRefresh(false);
 		// ItemUtils.EnclosedCheck(_body);
 		ItemUtils.Justify(this);
 	}
 	
-	public void redo() {
+	public void redo()
+	{
 		boolean bReparse = false;
 		boolean bRecalculate = false;
 
-		if (_redo.size() <= 0)
-			return;
+		if (_redo.size() <= 0) return;
 
 		History redo = _redo.pop();
@@ -1047,6 +1078,9 @@
 			break;
 		}
+		
 		change();
-		FrameMouseActions.getInstance().refreshHighlights();
+		
+		StandardGestureActions.refreshHighlights();
+		
 		if (bReparse) {
 			FrameUtils.Parse(this, false, false);
@@ -1054,9 +1088,9 @@
 			notifyObservers(bRecalculate);
 		}
+		
 		// always request a refresh otherwise filled shapes
 		// that were broken by a deletion and then reconnected by the undo
 		// don't get filled until the user otherwise causes them to redraw
-		FrameGraphics.requestRefresh(false);
-		FrameGraphics.Repaint();
+		DisplayController.requestRefresh(false);
 		// ItemUtils.EnclosedCheck(_body);
 		ItemUtils.Justify(this);
@@ -1068,9 +1102,11 @@
 	 * @return The name of this Frame's frameset.
 	 */
-	public String getFramesetName() {
+	public String getFramesetName()
+	{
 		return _frameset;
 	}
 
-	public String getName() {
+	public String getName()
+	{
 		return getFramesetName() + _number;
 	}
@@ -1081,58 +1117,69 @@
 	 * @return The version of this Frame.
 	 */
-	public int getVersion() {
+	public int getVersion()
+	{
 		return _version;
 	}
 
-	public PermissionPair getPermission() {
+	public PermissionPair getPermission()
+	{
 		return _permissionPair;
 	}
 	
-	public UserAppliedPermission getUserAppliedPermission() {
+	public UserAppliedPermission getUserAppliedPermission()
+	{
 		return getUserAppliedPermission(UserAppliedPermission.full);
 	}
 
-	public UserAppliedPermission getUserAppliedPermission(UserAppliedPermission defaultPermission) {
-		if (_permissionPair == null)
-			return defaultPermission;
+	public UserAppliedPermission getUserAppliedPermission(UserAppliedPermission defaultPermission)
+	{
+		if (_permissionPair == null) return defaultPermission;
 
 		return _permissionPair.getPermission(_owner);
 	}
 
-	
-	public String getOwner() {
+	public String getOwner()
+	{
 		return _owner;
 	}
 
-	public String getDateCreated() {
+	public String getDateCreated()
+	{
 		return _creationDate;
 	}
 
-	public String getLastModifyUser() {
+	public String getLastModifyUser()
+	{
 		return _modifiedUser;
 	}
 
-	public String getLastModifyDate() {
+	public String getLastModifyDate()
+	{
 		return _modifiedDate;
 	}
 
-	public String getFrozenDate() {
+	public String getFrozenDate()
+	{
 		return _frozenDate;
 	}
 
-	public void setBackgroundColor(Color back) {
+	public void setBackgroundColor(Colour back)
+	{
 		_background = back;
+		
 		change();
 
-		if (this == DisplayIO.getCurrentFrame()) {
-			FrameGraphics.refresh(false);
-		}
-	}
-
-	public Color getBackgroundColor() {
+		if (this == DisplayController.getCurrentFrame()) {
+			DisplayController.requestRefresh(false);
+		}
+	}
+
+	public Colour getBackgroundColor()
+	{
 		return _background;
 	}
 
-	public Color getPaintBackgroundColor() {
+	public Colour getPaintBackgroundColor()
+	{
 		// If null... return white
 		if (_background == null) {
@@ -1143,29 +1190,32 @@
 	}
 
-	public void setForegroundColor(Color front) {
+	public void setForegroundColor(Colour front)
+	{
 		_foreground = front;
+		
 		change();
-		// FrameGraphics.Repaint();
-	}
-
-	public Color getForegroundColor() {
+	}
+
+	public Colour getForegroundColor()
+	{
 		return _foreground;
 	}
 
-	public Color getPaintForegroundColor() {
-		final int GRAY = Color.gray.getBlue();
-		final int THRESHOLD = 10;
+	public Colour getPaintForegroundColor()
+	{
+		final int GRAY = Colour.GREY.getBlue();
+		final int THRESHOLD = Colour.FromComponent255(10);
 
 		if (_foreground == null) {
-			Color back = getPaintBackgroundColor();
+			Colour back = getPaintBackgroundColor();
 			if (Math.abs(back.getRed() - GRAY) < THRESHOLD
 					&& Math.abs(back.getBlue() - GRAY) < THRESHOLD
 					&& Math.abs(back.getGreen() - GRAY) < THRESHOLD)
-				return Color.WHITE;
-
-			Color fore = new Color(
-					Math.abs(Conversion.RGB_MAX - back.getRed()), Math
-							.abs(Conversion.RGB_MAX - back.getGreen()), Math
-							.abs(Conversion.RGB_MAX - back.getBlue()));
+			{
+				return Colour.WHITE;
+			}
+			
+			Colour fore = back.inverse();
+			
 			return fore;
 		}
@@ -1174,5 +1224,6 @@
 	}
 
-	public String toString() {
+	public String toString()
+	{
 		StringBuilder s = new StringBuilder();
 		s.append(String.format("Name: %s%d%n", _frameset, _number));
@@ -1187,7 +1238,9 @@
 	}
 
-	public Text getTextAbove(Text current) {
+	public Text getTextAbove(Text current)
+	{
 		Collection<Text> currentTextItems = FrameUtils.getCurrentTextItems();
 		List<Text> toCheck = new ArrayList<Text>();
+		
 		if (currentTextItems.contains(current)) {
 			toCheck.addAll(currentTextItems);
@@ -1195,35 +1248,20 @@
 			toCheck.addAll(getTextItems());
 		}
+		
 		// Make sure the items are sorted
 		Collections.sort(toCheck);
 
 		int ind = toCheck.indexOf(current);
-		if (ind == -1)
-			return null;
+		if (ind == -1) return null;
 
 		// loop through all items above this one, return the first match
 		for (int i = ind - 1; i >= 0; i--) {
 			Text check = toCheck.get(i);
-			if (FrameUtils.inSameColumn(check, current))
-				return check;
+			if (FrameUtils.inSameColumn(check, current)) return check;
 		}
 
 		return null;
 	}
-
-	/**
-	 * Updates any Images that require it from their ImageObserver (Principally
-	 * Animated GIFs)
-	 */
-	public boolean imageUpdate(Image img, int infoflags, int x, int y,
-			int width, int height) {
-		FrameGraphics.ForceRepaint();
-
-		if (DisplayIO.getCurrentFrame() == this)
-			return true;
-
-		return false;
-	}
-
+	
 	/**
 	 * Gets the text items that are in the same column and below a specified
@@ -1233,8 +1271,8 @@
 	 *            The Item to get the column for.
 	 */
-	public List<Text> getColumn(Item from) {
+	public List<Text> getColumn(Item from)
+	{
 		// Check that this item is on the current frame
-		if (!_body.contains(from))
-			return null;
+		if (!_body.contains(from)) return null;
 
 		if (from == null) {
@@ -1242,10 +1280,10 @@
 		}
 
-		if (from == null)
-			return null;
+		if (from == null) return null;
 
 		// Get the enclosedItems
 		Collection<Text> enclosed = FrameUtils.getCurrentTextItems();
 		List<Text> toCheck = null;
+		
 		if (enclosed.contains(from)) {
 			toCheck = new ArrayList<Text>();
@@ -1256,6 +1294,6 @@
 
 		List<Text> column = new ArrayList<Text>();
+		
 		if (toCheck.size() > 0) {
-
 			// Make sure the items are sorted
 			Collections.sort(toCheck);
